unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, Menus, Messages, Variants;

type

  { TForm1 }

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure MenuItem1Click(Sender: TObject);
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel5MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel6MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel7MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel8MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 
 type  miesto=record
          x:1..3;
          y:1..3;
          end;
var
  Form1: TForm1; 
  panel:array [1..8] of miesto;
  obsadene:array[1..3,1..3] of boolean;
  cislo:array[1..3,1..3] of integer;
  i,j,p,q:integer;
  cas:real;
implementation
 function konec:boolean;
var pocet,cyklus:integer;
begin
pocet:=0; cyklus:=0;
for i:= 1 to 3 do
  for j:= 1 to 3 do
  begin
  inc(cyklus);
  if cislo[i,j]=cyklus then inc(pocet);
  end;
if pocet=8 then result:=true
else result:=false;
end;

procedure vykreslenie;
var x,y:integer;
begin
x:=panel[1].x;y:=panel[1].y;
form1.Panel1.Left:=((50*x)+1)-50;form1.Panel1.top:=((50*y)+1)-50;

x:=panel[2].x;y:=panel[2].y;
form1.Panel2.Left:=((50*x)+1)-50;form1.Panel2.top:=((50*y)+1)-50;

x:=panel[3].x;y:=panel[3].y;
form1.Panel3.Left:=((50*x)+1)-50;form1.Panel3.top:=((50*y)+1)-50;

x:=panel[4].x;y:=panel[4].y;
form1.Panel4.Left:=((50*x)+1)-50;form1.Panel4.top:=((50*y)+1)-50;

x:=panel[5].x;y:=panel[5].y;
form1.Panel5.Left:=((50*x)+1)-50;form1.Panel5.top:=((50*y)+1)-50;

x:=panel[6].x;y:=panel[6].y;
form1.Panel6.Left:=((50*x)+1)-50;form1.Panel6.top:=((50*y)+1)-50;

x:=panel[7].x;y:=panel[7].y;
form1.Panel7.Left:=((50*x)+1)-50;form1.Panel7.top:=((50*y)+1)-50;

x:=panel[8].x;y:=panel[8].y;
form1.Panel8.Left:=((50*x)+1)-50;form1.Panel8.top:=((50*y)+1)-50;

end;
procedure volne;
begin
for i:= 1 to 3 do
    for j:= 1 to 3 do
    obsadene[i,j]:=false;
end;

procedure rozmiestnenie;
var pocet,x,y:integer;
begin
pocet:=1;
while pocet<>9 do
  begin
  x:=random(3)+1;
  y:=random(3)+1;
  if (obsadene[y,x]=false) and ((x<>3) or (y<>3)) then begin
                              panel[pocet].x:=x;
                              panel[pocet].y:=y;
                              obsadene[y,x]:=true;
                              cislo[y,x]:=pocet;
                              inc(pocet);
                              end;
   end;
end;
{ TForm1 }

procedure TForm1.MenuItem1Click(Sender: TObject);
begin
volne;
rozmiestnenie;
vykreslenie;
cas:=0;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel1.BeginDrag(true);
p:=panel[1].x;
q:=panel[1].y;
end;

procedure TForm1.Panel2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel2.BeginDrag(true);
p:=panel[2].x;
q:=panel[2].y;
end;

procedure TForm1.Panel3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel3.BeginDrag(true);
p:=panel[3].x;
q:=panel[3].y
end;

procedure TForm1.Panel4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel4.BeginDrag(true);
p:=panel[4].x;
q:=panel[4].y;
end;

procedure TForm1.Panel5MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel5.BeginDrag(true);
p:=panel[5].x;
q:=panel[5].y;
end;

procedure TForm1.Panel6MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel6.BeginDrag(true);
p:=panel[6].x;
q:=panel[6].y;
end;

procedure TForm1.Panel7MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel7.BeginDrag(true);
p:=panel[7].x;
q:=panel[7].y;
end;

procedure TForm1.Panel8MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
panel8.BeginDrag(true);
p:=panel[8].x;
q:=panel[8].y;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
cas:=cas+form1.Timer1.Interval;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
form1.Timer1.Enabled:=false;
randomize;
volne;
rozmiestnenie;
vykreslenie;
cas:=0;form1.Timer1.Enabled:=true;
end;



procedure TForm1.FormDragDrop(Sender, Source: TObject; X, Y: Integer);
var a,b:integer;
begin
if source is tpanel then begin
                          a:=(x div 50)+1; b:=(y div 50)+1;
                          if (abs((p+q)-(a+b))=1) and (obsadene[b,a]=false) then begin
                                                      tpanel(source).left:=(a-1)*50+1 ;
                                                        tpanel(source).top:=(b-1)*50+1;
                                                        obsadene[b,a]:=true;
                                                        obsadene[q,p]:=false;
                                                      panel[cislo[q,p]].x:=a;
                                                      panel[cislo[q,p]].y:=b;
                                                      cislo[b,a]:=cislo[q,p];
                                                      cislo[q,p]:=0;
                                                      if konec then begin
                                                                    showmessage('Vyhral si! tvoj cas je   '+floattostr(cas/1000)+'  sec');
                                                                     form1.Timer1.Enabled:=false;
                                                                    end;
                                                      end;
                          end;
end;

procedure TForm1.FormDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
accept:=(source is tpanel);
end;

initialization
  {$I unit1.lrs}

end.

